.so man.macros
.TH spline n 8.0 Tk "Tk Spline - An additional smoothing method for canvas items "
.BS
'\" Note:  do not modify the .SH NAME line immediately below!
.SH NAME
\fBspline\fR, \- additional smoothing method for canvas items.
.SH SYNOPSIS
.nf
	package require Tkspline
	...
	.c create line ... -smooth spline ...
	.c create polygon ... -smooth spline ...
.fo
.BE
.SH INTRODUCTION
.PP
The new option value: \fB-smooth spline\fR provides an additional smoothing method to
\fBline\fR and \fBpolygon\fR canvas items.

.PP
Spline smoothing will revert to the builtin smoothing method unless the number
of points is 3n+1, where n is the number of spline segments.
(Normally in polygons this means 3n points because the last point of the spline
is understood to be the same as the first in order to close the polygon).

.PP
In \fBline\fR and \fBpolygon\fR items, the curves generated with the standard
\fB-smooth true\fR option have the following properties:
.TP 3
-
the curve is always tangential to a straight line between consecutive points.
.TP 3 
-
the curve is only guaranteed to intersect the first and last points of \fBline\fRs. 
.TP 3 
- 
the curve is not guaranteed to intersect any points of \fBpolygon\fRs.

.PP
With \fB-smooth spline\fR (and the right number of coordinates) 
the curves generated have the following different properties:
.TP 3
-
the curve is guaranteed to intersect the first point, and every third point after that.
.TP 3
-
each segment of the curve shares endpoints with the adjacent segments,
but is otherwise independant of them.  
.TP 3
-
the curve is guaranteed to be tangential to a line between n and n+1 at 
point n, and also to a line between n+2 and n+3 at point n+3. 
.TP 3
-
the curve is not guaranteed to be smooth at the junctions between 
segments unless the shared point and the points either side of it are 
on a straight line.

.PP
These alternative properties are useful to some path planning algorithms.

.SH CREDITS
The underlying Bezier code is in John Ousterhout's original
canvas widget, this extension just provides an alternate interface
to it.   The hooks into the canvas are provided by Jan Nijtmans in 
his "dash" patch.

.SH KEYWORDS
spline, line, polygon, bezier, canvas, widget

.SH AUTHOR
John Ellson, ellson@lucent.com
